Main Page Widgets Namespaces Book

# Gtk::Calendar Class Reference
[Widgets]

Inheritance diagram for Gtk::Calendar:

[legend]

List of all members.

## Detailed Description

Display a calendar and/or allow the user to select a date.

This is a widget that displays a calendar, one month at a time.

The month and year currently displayed can be altered with select_month(). The exact day can be selected from the displayed month using select_day().

The way in which the calendar itself is displayed can be altered using set_display_options().

The selected date can be retrieved from a GtkCalendar using get_date().

If performing many 'mark' operations, the calendar can be frozen to prevent flicker, using freeze(), and 'thawed' again using thaw().

The Calendar widget looks like this:

## Public Types

typedef sigc::slot < Glib::ustring, guint, guint, guint > | SlotDetails
| For instance,.

## Public Member Functions

| Calendar ()
void | clear_marks ()
| Remove all visual markers.
void | display_options (CalendarDisplayOptions flags)
| Sets display options (whether to display the heading and the month headings).
void | freeze ()
| Does nothing.
void | get_date (Glib::Date& date) const
| Get the date as Glib::Date.
void | get_date (guint& year, guint& month, guint& day) const
| Obtains the selected date from a Gtk::Calendar.
int | get_detail_height_rows () const
int | get_detail_width_chars () const
CalendarDisplayOptions | get_display_options () const
| Return value: the display options.
const GtkCalendar* | gobj () const
| Provides access to the underlying C GtkObject.
GtkCalendar* | gobj ()
| Provides access to the underlying C GtkObject.
int | mark_day (guint day)
| Places a visual marker on a particular day.
Glib::PropertyProxy_ReadOnly<int> | property_day () const
| The selected day (as a number between 1 and 31, or 0 to unselect the currently selected day).
Glib::PropertyProxy<int> | property_day ()
| The selected day (as a number between 1 and 31, or 0 to unselect the currently selected day).
Glib::PropertyProxy_ReadOnly<int> | property_detail_height_rows () const
| Details height in rows.
Glib::PropertyProxy<int> | property_detail_height_rows ()
| Details height in rows.
Glib::PropertyProxy_ReadOnly<int> | property_detail_width_chars () const
| Details width in characters.
Glib::PropertyProxy<int> | property_detail_width_chars ()
| Details width in characters.
Glib::PropertyProxy_ReadOnly<int> | property_month () const
| The selected month (as a number between 0 and 11).
Glib::PropertyProxy<int> | property_month ()
| The selected month (as a number between 0 and 11).
Glib::PropertyProxy_ReadOnly <bool> | property_no_month_change () const
| If TRUE.
Glib::PropertyProxy<bool> | property_no_month_change ()
| If TRUE.
Glib::PropertyProxy_ReadOnly <bool> | property_show_day_names () const
| If TRUE.
Glib::PropertyProxy<bool> | property_show_day_names ()
| If TRUE.
Glib::PropertyProxy_ReadOnly <bool> | property_show_details () const
| If TRUE.
Glib::PropertyProxy<bool> | property_show_details ()
| If TRUE.
Glib::PropertyProxy_ReadOnly <bool> | property_show_heading () const
| If TRUE.
Glib::PropertyProxy<bool> | property_show_heading ()
| If TRUE.
Glib::PropertyProxy_ReadOnly <bool> | property_show_week_numbers () const
| If TRUE.
Glib::PropertyProxy<bool> | property_show_week_numbers ()
| If TRUE.
Glib::PropertyProxy_ReadOnly<int> | property_year () const
| The selected year.
Glib::PropertyProxy<int> | property_year ()
| The selected year.
void | select_day (guint day)
| Selects a day from the current month.
int | select_month (guint month, guint year)
| Shifts the calendar to a different month.
void | set_detail_func (const SlotDetails& slot)
| Installs a function which provides Pango markup with detail information for each day.
void | set_detail_height_rows (int rows)
void | set_detail_width_chars (int chars)
void | set_display_options (CalendarDisplayOptions flags)
| Sets display options (whether to display the heading and the month headings).
Glib::SignalProxy0<void> | signal_day_selected ()
Glib::SignalProxy0<void> | signal_day_selected_double_click ()
Glib::SignalProxy0<void> | signal_month_changed ()
Glib::SignalProxy0<void> | signal_next_month ()
Glib::SignalProxy0<void> | signal_next_year ()
Glib::SignalProxy0<void> | signal_prev_month ()
Glib::SignalProxy0<void> | signal_prev_year ()
void | thaw ()
| Does nothing.
int | unmark_day (guint day)
| Removes the visual marker from a particular day.
virtual | ~Calendar ()

## Protected Member Functions

virtual void | on_day_selected ()
virtual void | on_day_selected_double_click ()
virtual void | on_month_changed ()
virtual void | on_next_month ()
virtual void | on_next_year ()
virtual void | on_prev_month ()
virtual void | on_prev_year ()

## Related Functions

(Note that these are not member functions.)
Gtk::Calendar* | wrap (GtkCalendar* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Member Typedef Documentation

typedef sigc::slot<Glib::ustring, guint, guint, guint> Gtk::Calendar::SlotDetails

For instance,.

     Glib::ustring on_calendar_details(guint year, guint month, guint day);

Parameters:

  | year | The year for which details are needed.
  | month | The month for which details are needed.
  | day | The day of for which details are needed.

Returns:
  Pango markup with details for the specified day, or an empty string.

This callback function provides Pango markup with detail information for the specified day. Examples for such details are holidays or appointments. The function should return an empty string when no information is available.

Since gtkmm 2.14:

## Constructor & Destructor Documentation

virtual Gtk::Calendar::~Calendar | ( |  | ) | `[virtual]`

Gtk::Calendar::Calendar | ( |  | ) |

## Member Function Documentation

void Gtk::Calendar::clear_marks | ( |  | ) |

Remove all visual markers.

void Gtk::Calendar::display_options | ( | CalendarDisplayOptions | flags | ) |

Sets display options (whether to display the heading and the month headings).

Deprecated: 2.4: Use set_display_options() instead

Parameters:

  | flags | The display options to set.

void Gtk::Calendar::freeze | ( |  | ) |

Does nothing.

Previously locked the display of the calendar until it was thawed with thaw().

Deprecated: 2.8:

void Gtk::Calendar::get_date | ( | Glib::Date & | date | ) | const

Get the date as Glib::Date.

Parameters:

  | date | Referenz to set the date

void Gtk::Calendar::get_date | ( | guint & | year,
|  | guint & | month,
|  | guint & | day |
| ) |  |  | const

Obtains the selected date from a Gtk::Calendar.

Parameters:

  | year | Location to store the year number, or `0`.
  | month | Location to store the month number (between 0 and 11), or `0`.
  | day | Location to store the day number (between 1 and 31), or `0`.

int Gtk::Calendar::get_detail_height_rows | ( |  | ) | const

int Gtk::Calendar::get_detail_width_chars | ( |  | ) | const

CalendarDisplayOptions Gtk::Calendar::get_display_options | ( |  | ) | const

Return value: the display options.

Returns:
  The display options.

Since gtkmm 2.4:

const GtkCalendar* Gtk::Calendar::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Widget.

References Glib::ValueBase::gobject_.

GtkCalendar* Gtk::Calendar::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Widget.

References Glib::ValueBase::gobject_.

int Gtk::Calendar::mark_day | ( | guint | day | ) |

Places a visual marker on a particular day.

Parameters:

  | day | The day number to mark between 1 and 31.

Returns:
  `true`, always.

virtual void Gtk::Calendar::on_day_selected | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Calendar::on_day_selected_double_click | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Calendar::on_month_changed | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Calendar::on_next_month | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Calendar::on_next_year | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Calendar::on_prev_month | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Calendar::on_prev_year | ( |  | ) | `[protected, virtual]`

Glib::PropertyProxy_ReadOnly<int> Gtk::Calendar::property_day | ( |  | ) | const

The selected day (as a number between 1 and 31, or 0 to unselect the currently selected day).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::Calendar::property_day | ( |  | ) |

The selected day (as a number between 1 and 31, or 0 to unselect the currently selected day).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::Calendar::property_detail_height_rows | ( |  | ) | const

Details height in rows.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::Calendar::property_detail_height_rows | ( |  | ) |

Details height in rows.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::Calendar::property_detail_width_chars | ( |  | ) | const

Details width in characters.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::Calendar::property_detail_width_chars | ( |  | ) |

Details width in characters.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::Calendar::property_month | ( |  | ) | const

The selected month (as a number between 0 and 11).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::Calendar::property_month | ( |  | ) |

The selected month (as a number between 0 and 11).

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Calendar::property_no_month_change | ( |  | ) | const

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Calendar::property_no_month_change | ( |  | ) |

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Calendar::property_show_day_names | ( |  | ) | const

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Calendar::property_show_day_names | ( |  | ) |

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Calendar::property_show_details | ( |  | ) | const

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Calendar::property_show_details | ( |  | ) |

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Calendar::property_show_heading | ( |  | ) | const

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Calendar::property_show_heading | ( |  | ) |

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Calendar::property_show_week_numbers | ( |  | ) | const

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Calendar::property_show_week_numbers | ( |  | ) |

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::Calendar::property_year | ( |  | ) | const

The selected year.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::Calendar::property_year | ( |  | ) |

The selected year.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gtk::Calendar::select_day | ( | guint | day | ) |

Selects a day from the current month.

Parameters:

  | day | The day number between 1 and 31, or 0 to unselect the currently selected day.

int Gtk::Calendar::select_month | ( | guint | month,
|  | guint | year |
| ) |  |  |

Shifts the calendar to a different month.

Parameters:

  | month | A month number between 0 and 11.
  | year | The year the month is in.

Returns:
  `true`, always.

void Gtk::Calendar::set_detail_func | ( | const SlotDetails& | slot | ) |

Installs a function which provides Pango markup with detail information for each day.

Examples for such details are holidays or appointments. That information is shown below each day when show-details is set. A tooltip containing full detail information is provided if the entire text could not fit into the details area, or if the show-details property is not set.

The size of the details area can be restricted by setting the detail-width-chars and detail-height-rows properties.

Parameters:

  | slot | A callback function providing details for each day.

Since gtkmm 2.14:

void Gtk::Calendar::set_detail_height_rows | ( | int | rows | ) |

void Gtk::Calendar::set_detail_width_chars | ( | int | chars | ) |

void Gtk::Calendar::set_display_options | ( | CalendarDisplayOptions | flags | ) |

Sets display options (whether to display the heading and the month headings).

Since gtkmm 2.4:

Parameters:

  | flags | The display options to set.

Glib::SignalProxy0< void > Gtk::Calendar::signal_day_selected | ( |  | ) |

Prototype:
  `void on_my_day_selected()`

Glib::SignalProxy0< void > Gtk::Calendar::signal_day_selected_double_click | ( |  | ) |

Prototype:
  `void on_my_day_selected_double_click()`

Glib::SignalProxy0< void > Gtk::Calendar::signal_month_changed | ( |  | ) |

Prototype:
  `void on_my_month_changed()`

Glib::SignalProxy0< void > Gtk::Calendar::signal_next_month | ( |  | ) |

Prototype:
  `void on_my_next_month()`

Glib::SignalProxy0< void > Gtk::Calendar::signal_next_year | ( |  | ) |

Prototype:
  `void on_my_next_year()`

Glib::SignalProxy0< void > Gtk::Calendar::signal_prev_month | ( |  | ) |

Prototype:
  `void on_my_prev_month()`

Glib::SignalProxy0< void > Gtk::Calendar::signal_prev_year | ( |  | ) |

Prototype:
  `void on_my_prev_year()`

void Gtk::Calendar::thaw | ( |  | ) |

Does nothing.

Previously defrosted a calendar; all the changes made since the last freeze() were displayed.

Deprecated: 2.8:

int Gtk::Calendar::unmark_day | ( | guint | day | ) |

Removes the visual marker from a particular day.

Parameters:

  | day | The day number to unmark between 1 and 31.

Returns:
  `true`, always.

## Friends And Related Function Documentation

Gtk::Calendar* wrap | ( | GtkCalendar * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- calendar.h